
% Generate an interesting looking PDE. First start diary so all of this will be
% saved to a file named 'stuff'. Then can cut and paste from it to the Fortran
% file. 

% Fri 13 Apr 2018, 14:22:32 : since this looks BORING, I did a transformation 
% on x and y to create the more cool-looking uhing in cool.f90 and cool.m.
diary stuff
syms x y  real
u(x,y) = sin(x+y) - cos(x-y) + 1/(2 + x^2 + y^2)

ux  = diff(u,x,1);
uxx = diff(u,x,2);

uy  = diff(u,y,1);
uyy = diff(u,y,2);

% PDE coefficient functions. These I just made up on the fly.
a(x,y) = exp(x - y)
b(x,y) = asinh(1 + x + y)
c(x,y) = pi*y
d(x,y) = x*y
e(x,y) = sym(1)    % Cannot just do e(x,y) = 1 here

f = a*uxx + b*uyy + c*ux + d*uy + e*u

% A better view of f(x,y):
pretty(f)

% The next extracts the subexpression used in the pretty(), viz. s = x^2 + y^2 + 2
[g, h] = subexpr(f,'s')

% So in the file coeffs.f90, I first define s = x^2 + y^2 + 2, and then the copy
% the expression for g to be f(x,y).  And then edit the ^ to become Fortran's
% exponentiation operator **, and numbers like 2 to be 2.0_real8.
% Also, define BC(x,y) = u(x,y) from above. That gives a PDE whos exact solution
% is known a priori.

diary off

